VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form SeaTalkTest 
   Caption         =   "SeaTalkTest"
   ClientHeight    =   4545
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10980
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   4545
   ScaleWidth      =   10980
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkMsg 
      Caption         =   "Show decoded info"
      Height          =   255
      Left            =   6000
      TabIndex        =   8
      Top             =   600
      Value           =   1  'Checked
      Width           =   3375
   End
   Begin VB.CheckBox chkData 
      Caption         =   "Show recognised datagrams"
      Height          =   255
      Left            =   6000
      TabIndex        =   7
      Top             =   960
      Value           =   1  'Checked
      Width           =   3495
   End
   Begin VB.CheckBox chkInp 
      Caption         =   "Show all input in Hex"
      Height          =   255
      Left            =   6000
      TabIndex        =   6
      Top             =   240
      Value           =   1  'Checked
      Width           =   4335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Open"
      Height          =   375
      Left            =   4800
      TabIndex        =   5
      Top             =   960
      Width           =   855
   End
   Begin VB.ListBox lstCOM 
      Height          =   780
      ItemData        =   "SeaTraceTest.frx":0000
      Left            =   4800
      List            =   "SeaTraceTest.frx":000D
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
   Begin VB.Frame Frame1 
      Caption         =   "Try SeaTalk Input Modes"
      Height          =   1215
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   4335
      Begin VB.OptionButton Option2 
         Caption         =   "Simulation f.e. using SeaSigma"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   600
         Value           =   -1  'True
         Width           =   4095
      End
      Begin VB.OptionButton Option1 
         Caption         =   "Instrument Bus"
         Height          =   375
         Left            =   120
         TabIndex        =   3
         Top             =   240
         Width           =   2415
      End
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4200
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.TextBox txtSeaTalk 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3015
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "SeaTraceTest.frx":0023
      Top             =   1440
      Width           =   10695
   End
End
Attribute VB_Name = "SeaTalkTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim SeaTalkMode As Integer

Private Sub chkMsg_Click()
Static chkDataOld As Integer
''If checked, we will also display the message
''we need to preserve the status of the check Box to also provide the hex representation of the message
    If chkMsg Then
        chkData = chkDataOld
    Else
        chkDataOld = chkData
        chkData = 2
    End If
End Sub

Private Sub Command1_Click()
''Opens and closes the Comm Port
    If MSComm1.PortOpen Then
        ''If port is open, we need to close it
        MSComm1.PortOpen = False
        AddText "Closed SeaTalkTest " & lstCOM & " " & Now: AddText
        Command1.Caption = "Open"
    Else
        ''If closed, then attempt to claim it for SeaTalk
        If SetSeaTalkCom(lstCOM.ListIndex + 1, MSComm1) Then
            AddText "Opened SeaTalkTest " & lstCOM & " " & Now: AddText
            Command1.Caption = "Close"
        End If
        'no else case needed, messgae is provided already
    End If
    ''if prot is open, we may not change it, so disable Com-Port List
    lstCOM.Enabled = Not MSComm1.PortOpen
End Sub

Private Sub Form_Load()
Const myPort = 1

    lstCOM.ListIndex = 0
    Option2_Click
    
    Me.Width = 0.7 * Screen.Width
    Me.Height = 0.7 * Screen.Height
    Me.Top = 0.05 * Screen.Height
    Me.Left = 0.05 * Screen.Width
    txtSeaTalk.Text = "Select SeaTalk Mode and Com Port, then click Open button"
End Sub

Private Sub Form_Resize()
    txtSeaTalk.Width = Me.Width - 400
    txtSeaTalk.Height = Me.Height - 2000
End Sub

Private Sub MSComm1_OnComm()
Dim msg As String, msgNum As Integer
Static myInp As String, myInpL As Integer
    '' event is triggered when caharcters received or errors raised
    ''First call sub to get the input from the port
    MSCommSeaTalkChar MSComm1, SeaTalkMode, msg, msgNum, myInp
    
    ''then display output as required
    If chkInp = 1 Then
        ''Display hex input data (this may be more than one byte)
        AddText myInp, "": myInp = "": myInpL = myInpL + 1
    Else
        myInp = ""
    End If
    If myInpL >= 16 Then
        ''skip to next line after 16 calls (may be a bit more than 16 bytes)
        AddText
        myInpL = 0
    End If
    If msg <> "" And chkMsg = 1 Then
        ''Display SeaTalk Message with hex data if required
        If chkData = 0 Then
            AddText Right(msg, Len(msg) - InStr(msg, "m:") - 1)
        Else
            AddText msg
        End If
        If chkInp = 1 Then AddText
        myInpL = 0
    End If
End Sub
Private Sub Option1_Click()
    SeaTalkMode = SeaTalkModeBoat
    AddText "SeaTalk Input on Boat: Parity bit is start of new datagram"
    AddText "P: parity detected and even bits --> start datagram"
    AddText "Q: parity detected and odd bits  --> start datagram"
    AddText "r: no parity dtcd and even bits  --> normal character"
    AddText "S: no parity dtcd and even bits  --> start datagram": AddText
End Sub
Private Sub Option2_Click()
    SeaTalkMode = SeaTalkModeSim
    AddText "SeaTalk Input in Computer Simulation: Regular Parity Check": AddText
End Sub
Sub AddText(Optional msg As String = "", Optional c As String = vbCrLf)
    txtSeaTalk.Text = txtSeaTalk.Text & c & msg
    txtSeaTalk.SelStart = Len(txtSeaTalk)
End Sub

